<?php

chdir('../../');
include_once("./include/auth.php");

# include_once("./include/config.php");
$cacti_base = dirname(__FILE__)."..". DIRECTORY_SEPARATOR."..";

if( file_exists($cacti_base."/include/global.php") )
{
// 	include_once($cacti_base."/include/global.php");
}
elseif (file_exists($cacti_base."/include/config.php") )
{
  //      include_once($cacti_base."/include/config.php");
}

include_once($config["library_path"] . "/database.php");
include_once($config["library_path"] . "/html_form.php");
include_once($config["library_path"] . "/html_form_template.php");

# chdir('plugins/superlinks');

$superlinks_contentdir = realpath(dirname(__FILE__).DIRECTORY_SEPARATOR.'content');
$superlinks_tabdir = realpath(dirname(__FILE__).DIRECTORY_SEPARATOR.'tab_images');


$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

switch ($action) {


	case 'delete_page':
       		if( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) ) page_delete($_REQUEST['id']);
        	header("Location: superlinks-mgmt.php");
        	break;

	case 'move_page_up':
		if( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) &&
			isset($_REQUEST['order']) && is_numeric($_REQUEST['order']) )
			page_move($_REQUEST['id'],$_REQUEST['order'],-1);
		header("Location: superlinks-mgmt.php");
		break;
	case 'move_page_down':
		if( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) &&
			isset($_REQUEST['order']) && is_numeric($_REQUEST['order']) )
			page_move($_REQUEST['id'],$_REQUEST['order'],+1);
		header("Location: superlinks-mgmt.php");
		break;

	case 'perms_add_user':
		if( isset($_REQUEST['pageid']) && is_numeric($_REQUEST['pageid'])
			&& isset($_REQUEST['userid']) && is_numeric($_REQUEST['userid'])
			)
		{
			perms_add_user($_REQUEST['pageid'],$_REQUEST['userid']);
			header("Location: superlinks-mgmt.php?action=perms_edit&id=".$_REQUEST['pageid']);
		}
		break;
	case 'perms_delete_user':
		if( isset($_REQUEST['pageid']) && is_numeric($_REQUEST['pageid'])
			&& isset($_REQUEST['userid']) && is_numeric($_REQUEST['userid'])
			)
		{
			perms_delete_user($_REQUEST['pageid'],$_REQUEST['userid']);
			header("Location: superlinks-mgmt.php?action=perms_edit&id=".$_REQUEST['pageid']);
		}
		break;
	case 'perms_edit':
		if( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) )
		{
			include_once($config["base_path"]."/include/top_header.php");
			perms_list($_REQUEST['id']);
			include_once($config["base_path"]."/include/bottom_footer.php");
		}
		else
		{
			print "Something got lost back there.";
		}
		break;

	case 'save':
		if( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) )
		{
			$id = $_REQUEST['id'];
			$title = mysql_real_escape_string($_REQUEST['title']);	
			$style = mysql_real_escape_string($_REQUEST['style']);	
			$filename = $_REQUEST['filename'];
		       
			// if the filename is a valid URL, don't sanitize it 
		        if (preg_match('/^((((ht|f)tp(s?))\:\/\/){1}\S+)/i',$filename)) {
				$file = mysql_real_escape_string($filename);
			}
			else
			{
				$file = preg_replace("/[^A-Za-z0-9_\.-]/","_",$filename);
				$file = mysql_real_escape_string($file);
			}
			$SQL = "update superlinks_pages set title='$title', style='$style', contentfile='$file' where id=$id";
			db_execute($SQL);
			update_tabimage($id,$title);
			
		}
		header("Location: superlinks-mgmt.php");
		break;

	case 'edit':
		include_once($config["base_path"]."/include/top_header.php");
		if( isset($_REQUEST['id']) && is_numeric($_REQUEST['id']) )
		{
			editpage($_REQUEST['id']);
		}
		include_once($config["base_path"]."/include/bottom_footer.php");
		break;

	case 'addpage_picker':
		include_once($config["base_path"]."/include/top_header.php");
		addpage_picker();
		include_once($config["base_path"]."/include/bottom_footer.php");
		break;

	case 'addpage':
		if(isset($_REQUEST['file']))
		{
			$id=add_page($_REQUEST['file']);
			header("Location: superlinks-mgmt.php?action=edit&id=$id");
		}
		else
		{
			print "No such file.";
		}

		break;

	// by default, just list the page setup
default:
	include_once($config["base_path"]."/include/top_header.php");
	pagelist();

	print '<br />'; 
    html_end_box(); 

	include_once($config["base_path"]."/include/bottom_footer.php");
	break;
}

function pagelist()
{
	global $colors;
	global $superlinks_tabdir;

	if(!is_writable($superlinks_tabdir))
    {
		print "<div align=center style='margin: 10px;width: 60%; border:2px red solid; padding: 5px;'>You need to make sure that the tab_images/ directory is writable by the user that your webserver runs as. SuperLinks cannot create the tab graphics without this change.</div>";
	}

	if(!function_exists('imagepng'))
	{
		print "<div align=center style='margin: 10px;width: 60%; border:2px red solid; padding: 5px;'>Your mod_php should have the GD module enabled, with PNG support AND Freetype support. SuperLinks cannot create the tab graphics without this change.</div>";
	}
	elseif(!function_exists('imagettftext'))
	{
		print "<div align=center style='margin: 10px;width: 60%; border:2px red solid; padding: 5px;'>Your GD php module (and GD library/dll) need to be built with Freetype support. SuperLinks cannot create the tab graphics without this change.</div>";
	}

	html_start_box("<strong>Pages</strong>", "78%", $colors["header"], "3", "center", "superlinks-mgmt.php?action=addpage_picker");

	html_header(array("","Page", "Title", "Style","Sort Order", "Accessible By",""));

	$query = db_fetch_assoc("select id,username from user_auth");
	$users[0] = 'Anyone';

	foreach ($query as $user)
	{
		$users[$user['id']] = $user['username'];
	}

	$i = 0;
	$queryrows = db_fetch_assoc("select * from superlinks_pages order by sortorder");
	// or die (mysql_error("Could not connect to database") )

	$previous_id = -2;
	if( is_array($queryrows) )
	{
		foreach ($queryrows as $map)
		{
			form_alternate_row_color($colors["alternate"],$colors["light"],$i);

			print '<td><a href="?action=edit&id='.$map['id'].'"><img border=0 src="images/application_edit.png" /></a></td>';
			print '<td>'.htmlspecialchars($map['contentfile']).'</td>';
	#		print '<a href="?action=editor&plug=1&mapname='.htmlspecialchars($map['configfile']).'">[edit]</a></td>';
			print '<td>'.htmlspecialchars($map['title']).'</td>';
			print '<td>'.htmlspecialchars($map['style']).'</td>';
			
			print '<td>';

			print '<a href="?action=move_page_up&order='.$map['sortorder'].'&id='.$map['id'].'"><img src="../../images/move_up.gif" width="14" height="10" border="0" alt="Move Page Up"></a>';
			print '<a href="?action=move_page_down&order='.$map['sortorder'].'&id='.$map['id'].'"><img src="../../images/move_down.gif" width="14" height="10" border="0" alt="Move Page Down"></a>';
// print $map['sortorder'];

			print "</td>";

			print '<td>';
			$UserSQL = 'select * from superlinks_auth where pageid='.$map['id'].' order by userid';
			$userlist = db_fetch_assoc($UserSQL);

			$mapusers = array();
			foreach ($userlist as $user)
			{
				if(array_key_exists($user['userid'],$users))
				{
					$mapusers[] = $users[$user['userid']];
				}
			}

			print '<a href="?action=perms_edit&id='.$map['id'].'">';
			if(count($mapusers) == 0)
			{
				print "(no users)";
			}
			else
			{
				print join(", ",$mapusers);
			}
			print '</a>';

			print '</td>';
			//  print '<td><a href="?action=editor&mapname='.urlencode($map['configfile']).'">Edit Map</a></td>';
			print '<td>';
			print '<a href="?action=delete_page&id='.$map['id'].'"><img src="../../images/delete_icon.gif" width="10" height="10" border="0" alt="Delete Page"></a>';
			print '</td>';

			print '</tr>';
			$i++;
		}
	}

	if($i==0)
	{
		print "<tr><td><em>No Pages Configured</em></td></tr>\n";
	}

	html_end_box();
}

function addpage_picker()
{
	global $colors;
	global $superlinks_contentdir;

	$loaded=array();
	// find out what maps are already in the database, so we can skip those
	$queryrows = db_fetch_assoc("select * from superlinks_pages");
	if( is_array($queryrows) )
	{
		foreach ($queryrows as $map)
		{
			$loaded[]=$map['contentfile'];
		}
	}
	$loaded[]='index.php';

	html_start_box("<strong>Available SuperLinks Content Files</strong>", "78%", $colors["header"], "2", "center", "");

	if( is_dir($superlinks_contentdir))
	{
		$n=0;
		$dh = opendir($superlinks_contentdir);
		if($dh)
		{
			$i = 0; $skipped = 0;
			html_header(array("Content File", ""),2);

			while($file = readdir($dh))
			{
				$realfile = $superlinks_contentdir.'/'.$file;
				if(is_file($realfile) && ! in_array($file,$loaded) )
				{
					if(in_array($file,$loaded))
					{
						$skipped++;
					}
					else
					{
						$titles[$file] = 'xx';
						$i++;
					}
				}
			}
			closedir($dh);
			
				/* add generic http content first */
				form_alternate_row_color($colors["alternate"],$colors["light"],$i);
				print '<td>Generic Hypertext Document URL</td>';
				print '<td><a href="?action=addpage&amp;file=generic" title="Add the content file">Add</a></td>';
				print '</tr>';
				$i++;

			if($i>0)
			{
				ksort($titles);
			
				$i=0;

				foreach ($titles as $file=>$title)
				{
					$title = $titles[$file];
					form_alternate_row_color($colors["alternate"],$colors["light"],$i);
					print '<td>'.htmlspecialchars($file).'</td>';
					# print '<td><a href="?action=viewfile&amp;file='.$file.'" title="View the file in a new window" target="_blank">View</a></td>';
					print '<td><a href="?action=addpage&amp;file='.$file.'" title="Add the content file">Add</a></td>';
					print '</tr>';
					$i++;
				}
			}
			
			if( ($i + $skipped) == 0 )
			{
				print "<tr><td>No unused files were found in the content directory.</td></tr>";
			}		

			if( ($i == 0) && $skipped>0)
			{
				print "<tr><td>($skipped files weren't shown because they are already in the database)</td></tr>";
			}
		}
		else
		{
			print "<tr><td>Can't open $superlinks_contentdir to read - you should set it to be readable by the webserver.</td></tr>";
		}
	}
	else
	{
		print "<tr><td>There is no directory named $superlinks_contentdir - you will need to create it, and set it to be readable by the webserver. If you want to upload configuration files from inside Cacti, then it should be <i>writable</i> by the webserver too.</td></tr>";
	}

	html_end_box();

}

function page_delete($id)
{
	$SQL = "delete from superlinks_pages where id=".$id;
	db_execute($SQL);

	$SQL = "delete from superlinks_auth where pageid=".$id;
	db_execute($SQL);
	
	page_resort();
}

function perms_add_user($pageid,$userid)
{
	$SQL = "insert into superlinks_auth (pageid,userid) values($pageid,$userid)";
	db_execute($SQL);
}

function perms_delete_user($pageid,$userid)
{
	$SQL = "delete from superlinks_auth where pageid=$pageid and userid=$userid";
	db_execute($SQL);
}

function perms_list($id)
{
	global $colors;

	$title_sql = "select title from superlinks_pages where id=$id";
	$results = db_fetch_assoc($title_sql);
	$title = $results[0]['title'];

	$auth_sql = "select * from superlinks_auth where pageid=$id order by userid";

	$query = db_fetch_assoc("select id,username from user_auth order by username");
	$users[0] = 'Anyone';
	foreach ($query as $user)
	{
		$users[$user['id']] = $user['username'];
	}

	$auth_results = db_fetch_assoc($auth_sql);
	$mapusers = array();
	$mapuserids = array();
	foreach ($auth_results as $user)
	{
		if(isset($users[$user['userid']]))
		{
			$mapusers[] = $users[$user['userid']];
			$mapuserids[] = $user['userid'];
		}
	}

	$userselect="";
	foreach ($users as $uid => $name)
	{
		if(! in_array($uid,$mapuserids))    $userselect .= "<option value=\"$uid\">$name</option>\n";
	}

	html_start_box("<strong>Edit permissions for SuperLinks Page $id: $title</strong>", "70%", $colors["header"], "2", "center", "");
	html_header(array("Username", ""));

	$n = 0;
	foreach($mapuserids as $user)
	{
		form_alternate_row_color($colors["alternate"],$colors["light"],$n);
		print "<td>".$users[$user]."</td>";
		print '<td><a href="?action=perms_delete_user&pageid='.$id.'&userid='.$user.'"><img src="../../images/delete_icon.gif" width="10" height="10" border="0" alt="Remove permissions for this user to see this map"></a></td>';

		print "</tr>";
		$n++;
	}
	if($n==0)
	{
		print "<tr><td><em><strong>nobody</strong> can see this map</em></td></tr>";
	}
	html_end_box();

	html_start_box("", "70%", $colors["header"], "3", "center", "");
	print "<tr>";
	if($userselect == '')
	{
		print "<td><em>There aren't any users left to add!</em></td></tr>";
	}
	else
	{
		print "<td><form action=\"\">Allow <input type=\"hidden\" name=\"action\" value=\"perms_add_user\"><input type=\"hidden\" name=\"pageid\" value=\"$id\"><select name=\"userid\">";
		print $userselect;
		print "</select> to see this map <input type=\"submit\" value=\"Update\"></form></td>";
		print "</tr>";
	}
	html_end_box();
}

function page_resort()
{
	$list = db_fetch_assoc("select * from superlinks_pages order by sortorder;");
	$i = 1;
	foreach ($list as $map)
	{
		$sql[] = "update superlinks_pages set sortorder = $i where id = ".$map['id'];
		$i++;
	}
	if (!empty($sql)) {
		for ($a = 0; $a < count($sql); $a++) {
			$result = db_execute($sql[$a]);
		}
	}
}

function page_move($pageid,$junk,$direction)
{
	$source = db_fetch_assoc("select * from superlinks_pages where id=$pageid");
	$oldorder = $source[0]['sortorder'];

	$neworder = $oldorder + $direction;
	$target = db_fetch_assoc("select * from superlinks_pages where sortorder = $neworder");

	if(!empty($target[0]['id']))
	{
		$otherid = $target[0]['id'];
		// move $pageid in direction $direction
		$sql[] = "update superlinks_pages set sortorder = $neworder where id=$pageid";
		// then find the other one with the same sortorder and move that in the opposite direction
		$sql[] = "update superlinks_pages set sortorder = $oldorder where id=$otherid";
	}
	if (!empty($sql)) {
		for ($a = 0; $a < count($sql); $a++) {
			$result = db_execute($sql[$a]);
		}
	}
}


function add_page($file,$title='NewTab',$style='TAB')
{
        global $superlinks_contentdir;
        global $superlinks_tabdir;
        global $colors;

        chdir($superlinks_contentdir);

        $path_parts = pathinfo($file);
        $file_dir = realpath($path_parts['dirname']);
	if (($file_dir != $superlinks_contentdir) && ($file != "generic")) 
        {
                // someone is trying to read arbitrary files?
                // print "$file_dir != $weathermap_confdir";
                print "<h3>Path mismatch</h3>";
        }
        else
        {

		if($file == 'generic')
		{	
			$file = "http://www.cacti.net/";
		}
		else
		{
                	$realfile = $superlinks_contentdir.DIRECTORY_SEPARATOR.$file;
		}

                $file = mysql_real_escape_string($file);
                $etitle = mysql_real_escape_string($title);
                $SQL = "insert into superlinks_pages (contentfile,title,style) VALUES ('$file','$etitle','$style')";
                db_execute($SQL);

                // add auth for 'admin'
                $last_id = mysql_insert_id();
                $myuid = (int)$_SESSION["sess_user_id"];
                $SQL = "insert into superlinks_auth (pageid,userid) VALUES ($last_id,$myuid)";
                db_execute($SQL);

		update_tabimage($last_id,$title);

                page_resort();
		return $last_id;
        }

	return(-1);
}

function update_tabimage($id, $title)
{
	global $superlinks_tabdir;


	if(is_writable($superlinks_tabdir))
	{
		$oldsuffix = "";
		$current = db_fetch_assoc("select * from superlinks_pages where id=$id");
		$old1 = $superlinks_tabdir.DIRECTORY_SEPARATOR."tab_".$current[0]['imagecache'];
		$old2 = $superlinks_tabdir.DIRECTORY_SEPARATOR."red_".$current[0]['imagecache'];
		$old3 = $superlinks_tabdir.DIRECTORY_SEPARATOR."s_tab_".$current[0]['imagecache'];
		$old4 = $superlinks_tabdir.DIRECTORY_SEPARATOR."s_red_".$current[0]['imagecache'];
		if(file_exists($old1)) { unlink($old1); }
		if(file_exists($old2)) { unlink($old2); }
		if(file_exists($old3)) { unlink($old3); }
		if(file_exists($old4)) { unlink($old4); }
			
		$tabfilesuffix = $id."_".crc32($title)."_".session_id().".png";
			
		$tab=tabimage($title,"blank-tab-blue.png");
		$tabfile = "tab_".$tabfilesuffix;
		$tabfilefull = $superlinks_tabdir.DIRECTORY_SEPARATOR.$tabfile;
		imagepng($tab,$tabfilefull);
		imagedestroy($tab);

		$tab=tabimage($title,"blank-tab-red.png");
		$tabfile = "red_".$tabfilesuffix;
		$tabfilefull = $superlinks_tabdir.DIRECTORY_SEPARATOR.$tabfile;
		imagepng($tab,$tabfilefull);
		imagedestroy($tab);

		$tab=tabimage($title,"blank-tab-red-small.png",1);
		$tabfile = "s_red_".$tabfilesuffix;
		$tabfilefull = $superlinks_tabdir.DIRECTORY_SEPARATOR.$tabfile;
		imagepng($tab,$tabfilefull);
		imagedestroy($tab);

		$tab=tabimage($title,"blank-tab-blue-small.png",1);
		$tabfile = "s_tab_".$tabfilesuffix;
		$tabfilefull = $superlinks_tabdir.DIRECTORY_SEPARATOR.$tabfile;
		imagepng($tab,$tabfilefull);
		imagedestroy($tab);


		$SQL = "update superlinks_pages set imagecache='$tabfilesuffix' where id=$id";
		db_execute($SQL);
	}
	
}


function tabimage($text='ABC123',$source='blank-tab-blue.png',$size=0)
{
        $orig_cwd = getcwd();
        chdir(dirname(__FILE__));
	$originalpath = getenv('GDFONTPATH');
	putenv('GDFONTPATH=' . realpath('.'));
	
	//88 x 37				
	if($size==0)
	{
		$possibles = array(
			array("DejaVuSans-Bold.ttf",10,false),
			array("DejaVuSansCondensed-Bold.ttf",10,false),
			array("DejaVuSans-Bold.ttf",9,false),
			array("DejaVuSansCondensed-Bold.ttf",9,false),
			array("DejaVuSans-Bold.ttf",8,false),
			array("DejaVuSansCondensed-Bold.ttf",8,false),
			array("DejaVuSans-Bold.ttf",7,false),
			array("DejaVuSansCondensed-Bold.ttf",7,false),
			// Now, try the same last few, but with two lines of text
			//array("DejaVuSans-Bold.ttf",8,true),
			//array("DejaVuSansCondensed-Bold.ttf",8,true),
			array("DejaVuSans-Bold.ttf",7,true),
			array("DejaVuSansCondensed-Bold.ttf",7,true)
		);
		$y = 30;
        	$x = 44;
		$wlimit = 72;
		$wrapsize = 12;
	}

	// 60x25
	if($size==1)
	{
		$possibles = array(
			array("DejaVuSans-Bold.ttf",7,false),
			array("DejaVuSansCondensed-Bold.ttf",7,false),
			// Now, try the same last few, but with two lines of text
			//array("DejaVuSans-Bold.ttf",8,true),
			//array("DejaVuSansCondensed-Bold.ttf",8,true),
			// array("DejaVuSans-Bold.ttf",7,true),
			array("DejaVuSansCondensed-Bold.ttf",7,true)
		);
		$y = 21;
        	$x = 30;
		$wlimit = 52;
		$wrapsize = 9;
	}
					
		$tab = imagecreatefrompng( realpath(dirname(__FILE__).'/images/'.$source) );	
		$white = imagecolorallocate($tab,255,255,255);

		foreach ($possibles as $variation)
		{
			$font = $variation[0];
			$fontsize = $variation[1];	
			
			$lines = array();
			
			// if no wrapping is requested, or no wrapping is possible...
			if( (!$variation[2]) || ($variation[2] && strpos($text,' ')===FALSE) )
			{		
				$bounds=imagettfbbox($fontsize, 0, $font, $text);
				$w = $bounds[4] - $bounds[0];
				$h = $bounds[1] - $bounds[5];
				$realx = $x - $w/2 -1;
				$lines[] = array($text,$font,$fontsize,$realx, $y);
				$maxw = $w;
			}
			else
			{
				$texts = explode("\n",wordwrap($text,$wrapsize),2);
				
				$line = 1;
				$maxw = 0;
				foreach ($texts as $txt)
				{
					$bounds=imagettfbbox($fontsize, 0, $font, $txt);
					$w = $bounds[4] - $bounds[0];
					$h = $bounds[1] - $bounds[5];
					$realx = $x - $w/2 -1;
					$realy = $y - $h * $line + 3;
					$lines[] = array($txt,$font,$fontsize,$realx, $realy);
					if($maxw<$w) $maxw=$w;
					
					$line--;
				}
			}
			
			if($maxw<$wlimit) break;
		}	
                        
		foreach ($lines as $line)
		{
			imagettftext($tab, $line[2], 0, $line[3], $line[4], $white, $line[1], $line[0] );
		}
                
	putenv('GDFONTPATH=' . $originalpath);
        chdir($orig_cwd);
 
        return($tab);
}

function editpage($id)
{
	global $colors;

	$SQL = 'select * from superlinks_pages where id='.$id;
	$data = db_fetch_assoc($SQL);
	$values_ar = array();

	$field_ar = array(
		"id" => array("friendly_name" => "Style", "method" => "hidden", "value"=>$id ) ,
		"style" => array("friendly_name" => "Style", "method" => "drop_array", "array" => array( "TAB" => "Top Tab", "CONSOLE"=>"Console Menu", "FRONT" => "Front Cacti Page", "LOGINBEFORE" => "Login Screen (above)", "LOGINAFTER" => "Login Screen (below)"), "description" => "Where should this page appear?", "value"=>$data[0]['style'] ) ,

		"title" => array("friendly_name" => "Tab/Menu Name", "method" => "textbox", "max_length"=>20, "description"=>"The text that will appear in the tab or menu. This should be all lower-case for tabs, to match Cacti tabs", "value"=>$data[0]['title']) ,
		"filename" => array("friendly_name" => "Content File/URL", "method" => "textbox", "max_length"=>512,"description"=>"The file that contains the content for this page. This can be a file in the content/ directory or a valid URL.", "value"=>$data[0]['contentfile']) 
		);

        html_start_box("<strong>Edit SuperLinks Page $id: ".$data[0]['title']."</strong>", "98%", $colors["header"], "3", "center", "");
 draw_edit_form( array("config"=>$values_ar, "fields"=>$field_ar) );
	html_end_box();

        form_save_button("superlinks-mgmt.php", "save");


	
}



// vim:ts=4:sw=4:
?>
